0001 DEBUG  ORG  0C9A0H    * LOADING ADDRESS : DEBUG.SOL
0002 *
0003 *
0004 * <<< PROGRAM TO REPAIR CRASHED ALS8 FILES >>>
0005 ***** WRITTEN BY DON VAN DYKE
0006 ***** DR. DOBB'S JOURNAL # 21; (VOL. 3,ISSUE 1)
0007 *
0008 *
0009         MVI    E,0     * # OF THE PASS
0010 LOOP    LHLD   POINTR  * GET BEGINNING OF THE FILE
0011         DCX    H       * MINUS 1
0012         MOV    B,H     * PUT A COPY IN "BC" REG.
0013         MOV    C,L     
0014         JMP    INIT    * INITIALIZE THE PROGRAM
0015 LOOP2   MOV    B,H     * COPY INTO "BC" REG.
0016         MOV    C,L
0017         INX    B       * INCREMENT THE POINTER
0018         INX    H       * ...AND THIS BY TWO
0019         INX    H
0020 INIT    MVI    D,1
0021 LABL3   MOV    A,M     * GET THE BYTE
0022         CPI    0DH     * END OF THE LINE ?
0023         JZ     ENDLN   * ...YES
0024         DCX    H       * ...NO, BACK UP
0025         MOV    A,M     * GET THE BYTE
0026         CPI    1       * END OF FILE ?
0027         JZ     EOF     * ...YES, CHECK PASS NUMBER
0028         INX    H       * ...OTHERWISE,CONTINUE
0029         MOV    A,H     * GET THE BYTE
0030         CPI    020H    * CONTROL CHARACTER ?
0031         JNC    OK      * ...CHARACTER IS O.K.
0032         MVI    M,' '   * PUT A BLANK IN THE FILE
0033 OK      INR    D       * INCREMENT LENGTH
0034         INX    H       * POINT TO NEXT
0035         JMP    LABL3   * ...DO IT
0036 ENDLN   INR    D       * INCREMENT LENGTH
0037         MOV    A,D     * GET THE LENGTH IN "A"
0038         STAX   B       * STORE IT IN THE FILE
0039         JMP    LOOP2   * NEXT LINE
0040 EOF     XRA    A       * MAKE "A" = 0
0041         CMP    E       * # OF PASS = 0  ?
0042         JNZ    FCHK    * GOTO 'ALS8' FCHK ROUTINE
0043         INR    E       * PASS = PASS + 1
0044         JMP    LOOP2   * DO THE SECOND PASS
0045 FCHK    EQU    0E6D3H  * 'ALS8' FCHK ROUTINE (ENTRY POINT)
0046 POINTR  EQU    0D005H
0047 ***
0048 *
0049 *
0050 ENDIT   END
