0000 *                                                 *
0001 *                                               *
0002 *                                               *
0003 *                                                  *
0004 *                                                 *
0005 *                                               *
0006 *                                            *
0007 *                                    *
0010 *                                               *
0022 LINE0  LXI SP,0C8FFH  * LOCATE STACK
0023        LXI H,START    * LOAD START ADDRESS
0024        LXI D,COUNT    * NUMBER OF BYTES
0025 LINE1  XRA            * CLR "A" REG.
0026        MVI M,00       * CLR TEST ADDRESS
0027        DCX D          * COUNT BYTES
0028        INX H          * INCREASE ADDRESS
0029        CMP D          * ...ALL LOADED ?
0030        JNZ LINE1      * ...IF NOT, DO NEXT ADDRESS
0031        CMP E
0032        JNZ LINE1
0033        LXI H,START    * LOAD START ADDRESS
0034        LXI D,COUNT    * LOAD TOTAL # OF BYTES
0035 LINE2  XRA            * CLR "A"
0036        CMP M          * LOCATION CLEAR ?
0037        CNZ PART2      * FAILED? ...CALL 'PRINT A'
0038        DCX D          * COUNT BYTES
0039        INX H          * INCREASE ADDRESS
0040        CMP D          * ...ALL LOADED?
0041        JNZ LINE2      * ...IF NOT, DO NEXT ADDRESS
0042        CMP E
0043        JNZ LINE2
0044        LXI H,START    * LOAD START ADDRESS
0045        LXI D,COUNT    * LOAD TOTAL # OF BYTES
0046 LINE3  XRA            * CLR "A" REG.
0047        CMP M          * LOCATION CLEAR ?
0048        CNZ LINE5      * FAILED? ...CALL 'PRINT B'
0049        MVI A,01       * LOAD '0000 0001' IN "A" REG.
0050 LINE4  MOV M,A        * MOVE TO TEST ADDRESS
0051        CMP M          * LOAD O.K.?
0052        CNZ LINE6      * FAILED? ...CALL 'PRINT C'
0053        RAL            * ROTATE BIT LEFT
0054        JNC LINE4      * 8 BITS CHECKED ?
0055        MVI A,0FFH     * LOAD '1111 1111' IN "A" REG.
0056        MOV M,A        * MOVE TO TEST ADDRESS
0057        CMP M          * LOAD O.K.?
0058        CNZ LINE7      * FAILED? ...CALL 'PRINT D'
0059        DCX D          * COUNT BYTES
0060        INX H          * INCREASE ADDRESS
0061        XRA            * CLR "A" REG.
0062        CMP D          * ...ALL LOADED ?
0063        JNZ LINE3      * ...IF NOT, DO NEXT ADDRESS
0064        CMP E
0065        JNZ LINE3
0066        CALL  LINE9    * CALL 'PRINT "BELL"'
0067        DCR   C        * COUNT REPEATS
0068        XRA            * CLEAR "A" REG.
0069        CMP   C        * ALL REPEATS DONE ?
0070        JNZ   LINE0    * IF NOT, DO IT AGAIN
0071 *
0100        JMP   0C004H   * JUMP TO <SOL> MONITOR
0101 *
0102 PART2  MVI B,41H      * LOAD 'A'
0103        JMP LINE8      * PRINT IT
0104 LINE5  MVI B,42H      * LOAD 'B'
0105        JMP LINE8      * PRINT IT
0106 LINE6  MVI B,43H      * LOAD 'C'
0107        JMP LINE8      * PRINT IT
0108 LINE7  MVI B,44H      * LOAD 'D'
0109 LINE8  PUSH  B        * SAVE REPEAT COUNT
0110        PUSH  H        * SAVE ADDRESS
0111        CALL  PRINT    * "PRINT" THE CHARACTER
0112        POP   H        * RESTORE ADDRESS
0113        CALL  ADDRS    * "PRINT" THE ADDRESS
0114        POP   B        * RESTORE REPEAT COUNT
0115        RET            * GO BACK TO MM-III.
0116 *
0117 LINE9  PUSH H         * SAVE ADDRESS
0118        MOV  H,B       * SET-UP FOR PRINTING COUNT
0119        MO   L,C
0120        PUSH B         * SAVE REPEAT COUNT
0121        MVI  B,07H     * LOAD "BELL" SYMBOL
0122        CALL PRINT     * "PRINT" THE CHARACTER
0123        CALL COUNT     * "PRINT" THE REPEAT COUNT
0124        POP  B         * RESTORE REPEAT COUNT
0125        POP  H         * RESTORE ADDRESS
0126        RET            * GO BACK TO MM-III.
0127 *
0128 *  <<<  EQUATES  >>>
0129 *
0130 PRINT  EQU 0C08AH     * <SOL> "PRINT CHAR."   ROUTINE
0131 COUNT  EQU 0C2D7H     * <SOL> "PRINT ADDRESS" ROUTINE
0132 START  EQU 0000H      * START OF MEMORY TEST
0133 COUNT  EQU 0BFFFH     * # OF BYTES TO TEST
0134 RPEAT  EQU 01H        * TEST REPEAT COUNT
0135 *
0140 ENDIT  END
